Index: /trunk/src/org/expeditee/gui/MessageBay.java
===================================================================
--- /trunk/src/org/expeditee/gui/MessageBay.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/MessageBay.java	(revision 1102)
@@ -19,273 +19,202 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Font;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.GraphicsEnvironment;
-import java.awt.Rectangle;
-import java.awt.RenderingHints;
-import java.awt.geom.Area;
-import java.awt.image.VolatileImage;
 import java.util.LinkedList;
 import java.util.List;
 
+import org.expeditee.Util;
 import org.expeditee.actions.Misc;
+import org.expeditee.core.Clip;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Font;
+import org.expeditee.core.Image;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
 
 /**
- * The bay at the bottom of the expeditee browser which displays messages. TODO
- * make it thread safe!
- * 
+ * The bay at the bottom of the expeditee browser which displays messages.
+ * TODO: Make it thread safe!
  */
 public final class MessageBay {
 
-
-	public static final int MESSAGE_BUFFER_HEIGHT = 105;
-
+	/** The distance from the top of the message bay to the Message frame link. */
 	private static final int MESSAGE_LINK_Y_OFFSET = 100;
 
+	/** TODO: Comment. cts16 */
 	private static final int MESSAGE_LINK_X = 50;
 
-	public static final Color ERROR_COLOR = Color.red;
-
+	/** TODO: Comment. cts16 */
+	public static final Colour ERROR_COLOR = Colour.RED;
+
+	/** TODO: Comment. cts16 */
 	public static final String MESSAGES_FRAMESET_NAME = "Messages";
 
-	// messages shown in the message window
+	/** The list of messages shown in the message bay. */
 	private static List<Item> _messages = new LinkedList<Item>();
+	
+	/** Messages which were delayed because they couldn't be shown at time of creation. */
+	private static List<DelayedMessage> _delayedMessages = new LinkedList<DelayedMessage>();
+
+	/** TODO: Comment. cts16 */
 	private static Text _status = null;
 
-	// buffer of the message window
-	private static VolatileImage _messageBuffer = null;
-
-	// creator for creating the message frames
+	/** Buffer image of the message window. */
+	private static Image _messageBuffer = null;
+
+	/** Creator for creating the message frames. */
 	private static FrameCreator _creator = null;
 
-	// font used for the messages
-	private static Font _messageFont = Font.decode("Serif-Plain-16");
-
-	// the number of messages currently shown (used for scrolling up)
+	/** Font used for the messages. */
+	private static Font _messageFont = new Font("Serif-Plain-16");
+
+	/** The number of messages currently shown (used for scrolling up). */
 	private static int _messageCount = 0;
 
-	// if true, error messages are not shown to the user
+	/** If true, error messages are not shown to the user. */
 	private static boolean _suppressMessages = false;
 
-	// The link to the message frameset
-	private static Item _messageLink = new Text(-2, "@"
-			+ MESSAGES_FRAMESET_NAME, Color.black, Color.white);
-
-	private static List<Rectangle> _dirtyAreas = new LinkedList<Rectangle>();
-
+	/** The link to the message frameset. */
+	private static Item _messageLink = new Text(-2, "@" + MESSAGES_FRAMESET_NAME, Colour.BLACK, Colour.WHITE);
+
+	/** TODO: Comment. cts16 */
 	private static String _lastMessage = null;
 
-	private MessageBay() {
-	}
-
-	/**
-	 * Syncs messsage bay size according to FrameGraphics max size.
-	 * 
-	 */
-	static void updateSize() {
-
-		_messageBuffer = null;
-
+	/** TODO: Comment. cts16 */
+	private static boolean isLinkInitialized = false;
+
+	/** Static-only class. */
+	private MessageBay()
+	{
+	}
+	
+	/** Whether the message bay is ready to display messages. */
+	public static boolean isReady()
+	{
+		return Browser.isInitComplete();
+	}
+
+	/** Syncs message bay size according to FrameGraphics max size. */
+	static void updateSize()
+	{
 		for(Item i : _messages) {
 			if(i != null) {
-				i.setOffset(0, -FrameGraphics.getMaxFrameSize().height);
-				// i.setMaxWidth(FrameGraphics.getMaxFrameSize().width);
+				i.setOffset(0, -DisplayController.getMessageBayPaintArea().getMinY());
 			}
 		}
 
-		_messageLink.setOffset(0, -FrameGraphics.getMaxFrameSize().height);
-		// _messageLink.setMaxWidth(FrameGraphics.getMaxFrameSize().width);
-		// _messageLink.setPosition(FrameGraphics.getMaxFrameSize().width
-		// - MESSAGE_LINK_Y_OFFSET, MESSAGE_LINK_X);
+		_messageLink.setOffset(0, -DisplayController.getMessageBayPaintArea().getMinY());
+
 		updateLink();
-		initBuffer();
-	}
-
-	/**
-	 * @param i
-	 * @return True if i is an item in the message bay
-	 */
-	public static boolean isMessageItem(Item i) {
-		
-		return _messages.contains(i) || i == _messageLink;
-	}
-
-	public synchronized static void addDirtyArea(Rectangle r) {
-		_dirtyAreas.add(r);
-	}
-
-	static synchronized int getMessageBufferHeight() {
-		if (_messageBuffer != null)
-			return _messageBuffer.getHeight();
-		return 0;
-	}
-
-	public synchronized static Item getMessageLink() {
+	}
+
+	/** Whether the given item is an item in the message bay. */
+	public static boolean isMessageItem(Item i)
+	{
+		return _messages.contains(i) || i == _messageLink || i == _status;
+	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static Item getMessageLink()
+	{
 		return _messageLink;
 	}
 
-	public synchronized static List<Item> getMessages() {
+	/** TODO: Comment. cts16 */
+	public synchronized static List<Item> getMessages()
+	{
 		return _messages;
 	}
 
-	public synchronized static boolean isDirty() {
-		return !_dirtyAreas.isEmpty();
-	}
-
-	public synchronized static void invalidateFullBay() {
-		if (_messageBuffer != null) {
-			_dirtyAreas.clear();
-			addDirtyArea(new Rectangle(0,
-					FrameGraphics.getMaxFrameSize().height, _messageBuffer
-							.getWidth(), _messageBuffer.getHeight()));
-		}
-	}
-
-	private synchronized static boolean initBuffer() {
-		if (_messageBuffer == null) {
-			if (FrameGraphics.isAudienceMode()
-					|| FrameGraphics.getMaxSize().width <= 0)
-				return false;
-
-			GraphicsEnvironment ge = GraphicsEnvironment
-					.getLocalGraphicsEnvironment();
-			_messageBuffer = ge.getDefaultScreenDevice()
-					.getDefaultConfiguration().createCompatibleVolatileImage(
-							FrameGraphics.getMaxSize().width,
-							MESSAGE_BUFFER_HEIGHT);
-		}
-		return true;
-	}
-
-	private static boolean isLinkInitialized = false;
-
-	private static void updateLink() {
-
-		if (!isLinkInitialized && FrameGraphics.getMaxSize().width > 0) {
+	/** Causes the entire message bay area to be invalidated. */
+	public synchronized static void invalidateFullBay()
+	{
+		DisplayController.invalidateArea(DisplayController.getMessageBayPaintArea());
+	}
+
+	/** TODO: Comment. cts16 */
+	private static void updateLink()
+	{
+		if (!isLinkInitialized && DisplayController.getFramePaintArea().getWidth() > 0) {
 			// set up 'Messages' link on the right hand side
-			_messageLink.setPosition(FrameGraphics.getMaxSize().width
-					- MESSAGE_LINK_Y_OFFSET, MESSAGE_LINK_X);
-			_messageLink.setOffset(0, -FrameGraphics.getMaxFrameSize().height);
+			_messageLink.setPosition(DisplayController.getMessageBayPaintArea().getWidth() - MESSAGE_LINK_Y_OFFSET, MESSAGE_LINK_X);
+			_messageLink.setOffset(0, -DisplayController.getMessageBayPaintArea().getMinY());
 			isLinkInitialized = true;
-
 		} else {
-			_messageLink.setPosition(FrameGraphics.getMaxSize().width
-					- MESSAGE_LINK_Y_OFFSET, MESSAGE_LINK_X);
-		}
-	}
-
-	/**
-	 * Repaints the message bay. Updates the message bay buffer and draws to
-	 * given graphics.
-	 * 
-	 * @param useInvalidation
-	 *            Set to true of repinting dirty areas only. Otherwise false for
-	 *            full-repaint.
-	 * 
-	 * @param g
-	 * 
-	 * @param background
-	 *            The color of the message background
-	 */
-	public static synchronized void refresh(boolean useInvalidation,
-			Graphics g, Color background) {
-
-		if(g == null)
-			return;
-		
-		if (FrameGraphics.getMaxSize().width <= 0)
-			return;
-
-		Area clip = null;
-
-		if (useInvalidation) { // build clip
-
-			if (!_dirtyAreas.isEmpty()) {
-
-				for (Rectangle r : _dirtyAreas) {
-					r.y = (r.y < 0) ? 0 : r.y;
-					r.x = (r.x < 0) ? 0 : r.x;
-					if (clip == null)
-						clip = new Area(r);
-					else
-						clip.add(new Area(r));
+			_messageLink.setPosition(DisplayController.getMessageBayPaintArea().getWidth() - MESSAGE_LINK_Y_OFFSET, MESSAGE_LINK_X);
+		}
+	}
+
+	/** TODO: Comment. cts16 */
+	public static Image getImage(Clip clip, Dimension size)
+	{
+		// Can't get an image with an invalid size
+		if (size == null || size.width <= 0 || size.height <= 0) return null;
+
+		// Update the buffer
+		updateBuffer(Item.DEFAULT_BACKGROUND, clip, size);
+		
+		// Return the image buffer
+		return _messageBuffer;
+	}
+
+	/** Updates the image buffer to reflect the current state of the message bay. */
+	private static void updateBuffer(Colour background, Clip clip, Dimension size)
+	{
+		// If the buffer doesn't exist or is the wrong size, recreate it
+		if (_messageBuffer == null || !_messageBuffer.getSize().equals(size)) {
+			_messageBuffer = Image.createImage(size, true);
+			clip = null; // Need to recreate the entire image;
+			updateSize();
+		}
+
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+		g.pushDrawingSurface(_messageBuffer);
+
+		if (clip != null) g.pushClip(clip);
+		g.setAntialiasing(true);
+		
+		g.clear(background);
+		
+		g.setFont(_messageFont);
+		
+		for (Item message : _messages) {
+			if (message != null) {
+				if (clip == null || clip.isNotClipped() || message.isInDrawingArea(clip.getBounds())) {
+					FrameGraphics.PaintItem(message);
 				}
-			} else
-				return; // nothing to render
-		}
-
-		_dirtyAreas.clear();
-
-		// Update the buffer
-		updateBuffer(background, clip);
-
-		// Now repaint to screen
-		if (!FrameGraphics.isAudienceMode()) {
-
-			// Translate clip to messagebox coords
-			// clip.transform(t) // TODO
-			// g.setClip(clip);
-
-			g.drawImage(_messageBuffer, 0, FrameGraphics.getMaxFrameSize().height, null);
-		}
-
-	}
-
-	private static void updateBuffer(Color background, Area clip) {
-		if (!initBuffer())
-			return;
-
-		Graphics2D g = _messageBuffer.createGraphics();
-
-		g.setClip(clip);
-
-		g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
-				RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
-		g.setColor(background);
-		g.fillRect(0, 0, FrameGraphics.getMaxSize().width,
-				MESSAGE_BUFFER_HEIGHT);
-		g.setFont(_messageFont);
-		g.setColor(Color.BLACK);
-		g.drawLine(0, 0, FrameGraphics.getMaxSize().width, 0);
-
-		for (Item t : _messages) {
-			if (t == null)
-				continue;
-			if (clip == null || t.isInDrawingArea(clip))
-				FrameGraphics.PaintItem(g, t);
-		}
-		if(_status != null)
-			FrameGraphics.PaintItem(g, _status);
-
-		if (// _messageLink.getLink() != null
-		// &&
-		(clip == null || _messageLink.isInDrawingArea(clip))) {
-			FrameGraphics.PaintItem(g, _messageLink);
-		}
-		g.dispose();
-
-	}
-
-	private static Text displayMessage(String message, String link,
-			List<String> actions, Color color) {
+			}
+		}
+		
+		if (_status != null) FrameGraphics.PaintItem(_status);
+
+		if (clip == null || clip.isNotClipped() || _messageLink.isInDrawingArea(clip.getBounds())) {
+			FrameGraphics.PaintItem(_messageLink);
+		}
+		
+		g.popDrawingSurface();
+	}
+
+	/** TODO: Comment. cts16 */
+	private static Text displayMessage(String message, String link, List<String> actions, Colour color)
+	{
 		return displayMessage(message, link, actions, color, true);
 	}
 
-	public synchronized static Text displayMessage(String message, String link, Color color,
-			boolean displayAlways, String action) {
+	/** TODO: Comment. cts16 */
+	public synchronized static Text displayMessage(String message, String link, Colour color, boolean displayAlways, String action)
+	{
 		List<String> actions = new LinkedList<String>();
-		if (action != null)
-			actions.add(action);
+		if (action != null) actions.add(action);
 		return displayMessage(message, link, actions, color, displayAlways);
 	}
-	
-	private static Text newMessage(String message, String link, List<String> actions, Color color) {
+
+	/** TODO: Comment. cts16 */
+	private static Text newMessage(String message, String link, List<String> actions, Colour color)
+	{
 		Text t = new Text(getMessagePrefix(true) + message);
 		t.setPosition(20, 15 + _messages.size() * 25);
-		t.setOffset(0, -FrameGraphics.getMaxFrameSize().height);
+		t.setOffset(0, -DisplayController.getFramePaintArea().getHeight());
 		t.setColor(color);
 		t.setLink(link);
@@ -296,15 +225,21 @@
 		return t;
 	}
-	
-	private synchronized static Text displayMessage(String message, String link,
-			List<String> actions, Color color, boolean displayAlways, boolean redraw) {
+
+	/** TODO: Comment. cts16 */
+	private synchronized static Text displayMessage(String message, String link, List<String> actions, Colour color, boolean displayAlways, boolean redraw)
+	{
+		assert (message != null);
+		
+		if (!isReady()) {
+			delayMessage(message, link, actions, color, displayAlways, redraw);
+			return null;
+		}
+		
 		System.out.println(message);
-		assert (message != null);
 
 		// Invalidate whole area
 		invalidateFullBay();
 
-		if (_suppressMessages)
-			return null;
+		if (_suppressMessages) return null;
 
 		if (!displayAlways && message.equals(_lastMessage)) {
@@ -312,9 +247,9 @@
 			return null;
 		}
+		
 		_lastMessage = message;
 
 		if (_creator == null) {
-			_creator = new FrameCreator(MESSAGES_FRAMESET_NAME,
-					FrameIO.MESSAGES_PATH, MESSAGES_FRAMESET_NAME, true, false);
+			_creator = new FrameCreator(MESSAGES_FRAMESET_NAME, FrameIO.MESSAGES_PATH, MESSAGES_FRAMESET_NAME, true, false);
 		}
 
@@ -336,9 +271,7 @@
 		_messageLink.setLink(_creator.getCurrent());
 
+		// TODO: Can we just make this DisplayController.requestRefresh()? cts16
 		if(redraw) {
-    		Graphics g = FrameGraphics.createGraphics();
-    		if (g != null) {
-    		    refresh(false, g, Item.DEFAULT_BACKGROUND);
-    		}
+			DisplayController.requestRefresh(true);
 		}
 
@@ -346,30 +279,36 @@
 	}
 
-	public synchronized static Text displayMessage(String message, String link,
-			List<String> actions, Color color, boolean displayAlways) {
+	/** TODO: Comment. cts16 */
+	public synchronized static Text displayMessage(String message, String link, List<String> actions, Colour color, boolean displayAlways)
+	{
 		return displayMessage(message, link, actions, color, displayAlways, true);
 	}
 
-	public synchronized static void overwriteMessage(String message) {
+	/** TODO: Comment. cts16 */
+	public synchronized static void overwriteMessage(String message)
+	{
 		overwriteMessage(message, null);
 	}
 
-	public synchronized static void overwriteMessage(String message, Color color) {
+	/** TODO: Comment. cts16 */
+	public synchronized static void overwriteMessage(String message, Colour color)
+	{
 		_messages.remove(_messages.size() - 1);
 		Text t = newMessage(message, null, null, color);
 		_messages.add(t);
-		Graphics g = FrameGraphics.createGraphics();
-		if (g != null) {
-		    refresh(false, g, Item.DEFAULT_BACKGROUND);
-		}
-	}
-	
-	private static String getMessagePrefix(int counter) {
+		DisplayController.requestRefresh(true);
+	}
+
+	/** TODO: Comment. cts16 */
+	private static String getMessagePrefix(int counter)
+	{
 		return "@" + counter + ": ";
 	}
 
-	private static String getMessagePrefix(boolean incrementCounter) {
-		if (incrementCounter)
-			_messageCount++;
+	/** TODO: Comment. cts16 */
+	private static String getMessagePrefix(boolean incrementCounter)
+	{
+		if (incrementCounter) _messageCount++;
+		
 		return getMessagePrefix(_messageCount);
 	}
@@ -382,18 +321,18 @@
 	 *            the message to be displayed
 	 */
-	public synchronized static Text linkedErrorMessage(String message) {
-		if (_suppressMessages)
-			return null;
+	public synchronized static Text linkedErrorMessage(String message)
+	{
+		if (_suppressMessages) return null;
 		Misc.beep();
 		String[] tokens = message.split(Text.FRAME_NAME_SEPARATOR);
 		String link = null;
-		if (tokens.length > 1)
-			link = tokens[tokens.length - 1];
+		if (tokens.length > 1) link = tokens[tokens.length - 1];
 		return displayMessage(message, link, null, ERROR_COLOR);
 	}
 
-	public synchronized static Text errorMessage(String message) {
-		if (_suppressMessages)
-			return null;
+	/** TODO: Comment. cts16 */
+	public synchronized static Text errorMessage(String message)
+	{
+		if (_suppressMessages) return null;
 		Misc.beep();
 		return displayMessage(message, null, null, ERROR_COLOR, false);
@@ -407,82 +346,115 @@
 	 *            The message to display to the user in the message area
 	 */
-	public synchronized static Text displayMessage(String message) {
+	public synchronized static Text displayMessage(String message)
+	{
 		return displayMessageAlways(message);
 	}
 
-	public synchronized static Text displayMessageOnce(String message) {
-		return displayMessage(message, null, null, Color.BLACK, false);
-	}
-
-	public synchronized static Text displayMessage(String message, Color textColor) {
+	/** TODO: Comment. cts16 */
+	public synchronized static Text displayMessageOnce(String message)
+	{
+		return displayMessage(message, null, null, Colour.BLACK, false);
+	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static Text displayMessage(String message, Colour textColor)
+	{
 		return displayMessage(message, null, null, textColor);
-		// Misc.Beep();
-	}
-
-	public synchronized static Text displayMessage(Text message) {
+	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static Text displayMessage(Text message)
+	{
 		Text t = null;
 		String link = message.getLink();
 		List<String> action = message.getAction();
-		Color color = message.getColor();
+		Colour color = message.getColor();
 		for (String s : message.getTextList()) {
 			t = displayMessage(s, link, action, color);
 		}
 		return t;
+	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static Text displayMessageAlways(String message)
+	{
+		return displayMessage(message, null, null, Colour.BLACK);
 		// Misc.Beep();
 	}
 
-	public synchronized static Text displayMessageAlways(String message) {
-		return displayMessage(message, null, null, Color.BLACK);
-		// Misc.Beep();
-	}
-
-	public synchronized static Text warningMessage(String message) {
-		return displayMessage(message, null, null, Color.MAGENTA);
-		// Misc.Beep();
-	}
-
-	public synchronized static void suppressMessages(boolean val) {
+	/** TODO: Comment. cts16 */
+	public synchronized static Text warningMessage(String message)
+	{
+		return displayMessage(message, null, null, Colour.MAGENTA);
+	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static List<Text> warningMessages(List<String> messages)
+	{
+		if (messages == null) return null;
+		List<Text> ret = new LinkedList<Text>();
+		for (String message : messages) ret.add(warningMessage(message));
+		return ret;
+	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static void suppressMessages(boolean val)
+	{
 		_suppressMessages = val;
 	}
-	
-	public synchronized static void setStatus(String status) {
+
+	/** TODO: Comment. cts16 */
+	public synchronized static void setStatus(String status)
+	{
 		if (_status == null) {
 			_status = new Text(status);
 			_status.setPosition(0, 85);
-			_status.setOffset(0, FrameGraphics.getMaxFrameSize().height);
+			_status.setOffset(0, -DisplayController.getMessageBayPaintArea().getMinY());
 			_status.setLink(null); // maybe link to a help frame?
-			_status.setFont(Font.decode(Text.MONOSPACED_FONT));
+			_status.setFont(new Font(Text.MONOSPACED_FONT));
 		} else {
 			_status.setText(status);
 		}
-		Graphics g = FrameGraphics.createGraphics();
-		if (g != null) {
-			refresh(false, g, Item.DEFAULT_BACKGROUND);
-		}
-	}
-	
-	public static final class Progress {
-		
-		private static final String filled = "\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592\u2592";
-		private static final String unfilled = "\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591\u2591";
-		
-		String message;
-		Text text;
-		
-		protected Progress(String text) {
-			this.text = displayMessage(text, null, null, Color.GREEN.darker(), true, false);
-			//this.text.setFont(Font.decode(Text.MONOSPACED_FONT + "-16"));
-			this.message = this.text.getText();
-			this.text.setText(this.message + " [" + unfilled + "] 0%");
-			refresh(false, FrameGraphics.createGraphics(), Item.DEFAULT_BACKGROUND);
-		}
-		
-		public void UpdateMessage(final String text, final int newProgress) throws Exception {
-			this.message = text;
+
+		//invalidateFullBay();
+		DisplayController.requestRefresh(true);
+	}
+
+	/** TODO: Comment. cts16 */
+	public static final class Progress
+	{
+		/** The colour progress bars should be displayed in. */
+		private static final Colour BAR_COLOUR = Colour.GREEN.darker();
+		
+		/** The character used to assemble the uncompleted portions of the progress bar. */
+		private static final char UNCOMPLETED_CHARACTER = '\u2591'; // ░
+		/** The character used to assemble the completed portions of the progress bar. */
+		private static final char COMPLETED_CHARACTER = '\u2592'; // ▒
+		
+		/** What the progress bar should look like when at 100% completion. */
+		private static final String COMPLETED_BAR = Util.nCopiesOf(20, COMPLETED_CHARACTER);
+		/** What the progress bar should look like when at 0% completion. */
+		private static final String UNCOMPLETED_BAR = Util.nCopiesOf(20, UNCOMPLETED_CHARACTER);
+		
+		private String _message;
+		private Text _text;
+		
+		protected Progress(String text)
+		{
+			this._text = displayMessage(text, null, null, BAR_COLOUR, true, false);
+			this._message = this._text.getText();
+			this._text.setText(this._message + " [" + UNCOMPLETED_BAR + "] 0%");
+			DisplayController.requestRefresh(true);
+		}
+		
+		public void UpdateMessage(final String text, final int newProgress) throws Exception
+		{
+			this._message = text;
 			set(newProgress);
 		}
 		
-		public String GetMessage() {
-			return message;
+		public String GetMessage()
+		{
+			return _message;
 		}
 		
@@ -493,10 +465,11 @@
 		 * @throws Exception if progress out of bounds
 		 */
-		public boolean set(int progress) throws Exception {
+		public boolean set(int progress) throws Exception
+		{
 			if(progress < 0 || progress > 100) throw new Exception("Progress value out of bounds");
 			int p = progress / 5;
-			if(isMessageItem(this.text)) {
-				this.text.setText(this.message + " [" + filled.substring(0, p) + unfilled.substring(p) + "] " + progress + "%");
-				refresh(false, FrameGraphics.createGraphics(), Item.DEFAULT_BACKGROUND);
+			if(isMessageItem(this._text)) {
+				this._text.setText(this._message + " [" + COMPLETED_BAR.substring(0, p) + UNCOMPLETED_BAR.substring(p) + "] " + progress + "%");
+				DisplayController.requestRefresh(true);
 				return true;
 			}
@@ -504,7 +477,56 @@
     	}
 	}
+
+	/** TODO: Comment. cts16 */
+	public synchronized static Progress displayProgress(String message)
+	{
+		return new Progress(message);
+	}
 	
-	public synchronized static Progress displayProgress(String message) {
-		return new Progress(message);
+	/** Remembers the arguments to a displayMessage call for later use. */ 
+	private static class DelayedMessage {
+		
+		private String _message;
+		private String _link;
+		private List<String> _actions;
+		private Colour _colour;
+		private boolean _displayAlways;
+		private boolean _redraw;
+		
+		public DelayedMessage(String message, String link, List<String> actions, Colour color, boolean displayAlways, boolean redraw)
+		{
+			_message = message;
+			_link = link;
+			if (actions == null) {
+				_actions = null;
+			} else {
+				_actions =  new LinkedList<String>();
+				_actions.addAll(actions);
+			}
+			_colour = color == null ? null : color.clone();
+			_displayAlways = displayAlways;
+			_redraw = redraw;
+		}
+		
+		public void display()
+		{
+			displayMessage(_message, _link, _actions, _colour, _displayAlways, _redraw);
+		}
+		
+	}
+	
+	private static void delayMessage(String message, String link, List<String> actions, Colour color, boolean displayAlways, boolean redraw)
+	{
+		_delayedMessages.add(new DelayedMessage(message, link, actions, color, displayAlways, redraw));
+	}
+	
+	public static void showDelayedMessages()
+	{
+		if (isReady()) {
+			for (DelayedMessage message : _delayedMessages) message.display();
+			_delayedMessages.clear();
+			invalidateFullBay();
+			DisplayController.requestRefresh(true);
+		}
 	}
 
Index: /trunk/src/org/expeditee/gui/Overlay.java
===================================================================
--- /trunk/src/org/expeditee/gui/Overlay.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Overlay.java	(revision 1102)
@@ -20,12 +20,19 @@
 
 import java.util.Collection;
+import java.util.LinkedList;
+import java.util.List;
 
 import org.expeditee.items.UserAppliedPermission;
+import org.expeditee.items.widgets.Widget;
 
+/** TODO: Comment. cts16 */
 public class Overlay {
+	/** TODO: Comment. cts16 */
 	public Frame Frame;
 
+	/** TODO: Comment. cts16 */
 	public UserAppliedPermission permission;
 
+	/** TODO: Comment. cts16 */
 	public Overlay(Frame overlay, UserAppliedPermission level) {
 		Frame = overlay;
@@ -34,7 +41,7 @@
 
 	@Override
-	public boolean equals(Object o) {
-		if (o == null || o.getClass() != Overlay.class)
-			return false;
+	public boolean equals(Object o)
+	{
+		if (!(o instanceof Overlay)) return false;
 
 		return ((Overlay) o).Frame == Frame;
@@ -42,9 +49,13 @@
 
 	@Override
-	public int hashCode() {
+	public int hashCode()
+	{
+		// TODO: Comment. cts16
 		return 0;
 	}
-	
-	public static Overlay getOverlay(Collection<Overlay>overlays, Frame frame){
+
+	/** TODO: Comment. cts16 */
+	public static Overlay getOverlay(Collection<Overlay> overlays, Frame frame)
+	{
 		// Check the frame is in the list of overlays
 		for (Overlay o : overlays) {
